
/**
 * Klasse Caesar.
 * 
 * @author claus albowski
 * @version okt'07
 */
public class Caesar
{
	private String original, chiffrat, dechiffrat;
	private char schluessel;

	/**
	 * Konstruktor fr Objekte der Klasse Caesar
	 */
	public Caesar()	{
		original = "ORIGINAL";
		chiffrat = "CHIFFRAT";
		dechiffrat = "DECHIFFRAT";
		schluessel = 'A';
	}
	
	/**
	 * setzt den Schlssel.
	 */
	public void setzeSchluessel(char buchstabe){
	    schluessel = buchstabe;
	}
	
	/**
	 * setzt den Originaltext.
	 */
	public void setzeOriginal(String text){
	    original=text.toUpperCase();
	}
	
	/**
	 * setzt den Chiffrattext.
	 */
	public void setzeChiffrat(String text){
	    chiffrat=text.toUpperCase();
	}
	
	/**
	 * zeigt das Chiffrat an.
	 */
	public String gibChiffrat(){
	    return chiffrat;
	}

	/**
	 * zeigt das Dechiffrat an.
	 */
	public String gibDechiffrat(){
	    return dechiffrat;
	}
	
	// bersetzungsmethoden:
	
	/**
	 * chiffriert ein einzelnes Zeichen
	 * mit dem definierten Schlsselbuchstaben.
	 */
	private char chiffriereEinZeichen(char zeichen) {
	    int zahl = (int) zeichen;
	    int key  = (int) schluessel;
	    int ergebnis = ((zahl-65 + schluessel-65) % 26) + 65;
	    return (char) ergebnis;
	}
	/**
	 * dechiffriert ein einzelnes Zeichen
	 * mit dem definierten Schlsselbuchstaben.
	 */
	private char dechiffriereEinZeichen(char zeichen) {
	    int zahl = (int) zeichen;
	    int key  = (int) schluessel;
	    int ergebnis = ((zahl-65 - (schluessel-65) + 26) % 26) + 65;
	    return (char) ergebnis;
	}
	
	/**
	 * chiffriert den Original-Text
	 * mit dem definierten Schlsselbuchstaben.
	 */
	public void chiffriere() {
	    StringBuffer temp = new StringBuffer();
	    for (int i=0; i<original.length();i++)
	    // Absicherung auf Grobuchstaben: if (original.charAt(i)>64) if (original.charAt(i)<91)
	    temp.append(chiffriereEinZeichen(original.charAt(i)));
	    chiffrat=temp.toString();
	   }
	   
	/**
	 * dechiffriert den Chiffrat-Text
	 * mit dem definierten Schlsselbuchstaben.
	 */
	public void dechiffriere() {
	    StringBuffer temp = new StringBuffer();
	    for (int i=0; i<chiffrat.length();i++)
	    // Absicherung auf Grobuchstaben: if (chiffrat.charAt(i)>64) if (chiffrat.charAt(i)<91)
	    temp.append(dechiffriereEinZeichen(chiffrat.charAt(i)));
	    dechiffrat=temp.toString();
	   }
}
